--
-- TurningLightV2
-- Specialization for turning lights for low config.
-- Version 2 : allows multiple turning lights and uses modDesc input bindings' system.
-- @author  Bayn ( www.tsforum3.com )
-- @date  27/09/09
--

TurningLightV2 = {};

function TurningLightV2.prerequisitesPresent(specializations)
    return true
end;

function TurningLightV2:load(xmlFile)

	self.numTurningLight = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.TurningLights#count"), 0);
	self.TurningLight = {};
	
	for i=1, self.numTurningLight do
	self.TurningLight[i] = {};
	local partnamei = string.format("vehicle.TurningLights.TurningLight".."%d",i);
	self.TurningLight[i].object = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
	self.TurningLight[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .."#rotNode"));
    self.TurningLight[i].lightFace = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .."#lightFace"));
    self.TurningLight[i].speed = Utils.getNoNil(getXMLInt(xmlFile, partnamei .."#rotSpeed"), 1)/1000;
	end;
	self.TurningLightOn = false;
		
end;

function TurningLightV2:delete()
end;

function TurningLightV2:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TurningLightV2:keyEvent(unicode, sym, modifier, isDown)
end;

function TurningLightV2:update(dt)

	if InputBinding.hasEvent(InputBinding.TLV2)  then
			self.TurningLightOn = not self.TurningLightOn;
	end;
	
	if self.TurningLightOn then
		for i=1, self.numTurningLight do
			rotate(self.TurningLight[i].rotNode, 0, dt*self.TurningLight[i].speed, 0);
			setVisibility(self.TurningLight[i].lightFace, true);
		end;	
	else
		for i=1, self.numTurningLight do
			setVisibility(self.TurningLight[i].lightFace, false);
		end;
	end;
	
end;

function TurningLightV2:draw()
	if self.TurningLightOn then
		g_currentMission:addExtraPrintText(string.format("Touche %s: Turning Light OFF", InputBinding.getButtonKeyName(InputBinding.TLV2)));
	else
		g_currentMission:addExtraPrintText(string.format("Touche %s: Turning Light ON", InputBinding.getButtonKeyName(InputBinding.TLV2)));
	end;
end;

